DECLARE SUB standardwdw (screenheight%)
DECLARE SUB LoadMonths ()
DECLARE SUB InitColors ()
DECLARE SUB PlanetDataLoad (t#)
DECLARE SUB RestorPlanets (target!(), source!())
DECLARE SUB inputstring (start$, p#, now$)
DECLARE SUB DrawPaths (planetpathX!(), planetpathY!(), s!)
DECLARE SUB headings (start$, t#, screenheight%, switch%, plan%, now$)
DECLARE SUB setcolor ()
DECLARE SUB ScaleChange (start$, s!, factor!, PlanetColor%, t#, screenheight%, switch%, plan%, now$)
DECLARE SUB ChangeTime (start$, t#, factor!, screenheight%, switch%, plan%, now$)
DECLARE FUNCTION ArcTan! (h!, v!)
DECLARE FUNCTION BritDate$ (a$)
DECLARE FUNCTION clock$ (chron#)
DECLARE FUNCTION CnvrtElapToDate$ (p#, start$)
DECLARE SUB plotPRINT (down!, across!, fore%, back%, a$)
DECLARE FUNCTION keycheck! (a!)
DECLARE SUB origin (Xorig#, Yorig#, wedth%, height%)
DECLARE FUNCTION RAD! (DEGREES!)
DECLARE FUNCTION SetScreenHeight! (dummy%)
DECLARE SUB DayAndMon (day%, realday%, month%)

'Mer = 1: Ven = 2: Ear = 3: Mar = 4
'Jup = 5: Sat = 6: Ura = 7: Nep = 8: Plu = 9

CONST firstp% = 1
CONST lastp% = 9
CONST pi = 3.141592653589#
CONST n% = 9:                     'number of planets
CONST G = 6.6732E-11
CONST m = 5.976E+24 * 332946:     'mass of Sun in kilograms
CONST PlanetColor% = 15
CONST trailimit% = 1818

s = 1.2E+09                   'scale
screenheight% = SetScreenHeight(0)
t# = 3600 / 4: 'plotting interval in seconds (1 day=86400) (1/4 hour)

DIM SHARED planetname$(1 TO 9)
DIM SHARED Planets(1 TO 9, 1 TO 6)
DIM SHARED backupplanets(1 TO 9, 1 TO 6)
DIM SHARED planetpathX(1 TO 9, 0 TO trailimit% + 1)
DIM SHARED planetpathY(1 TO 9, 0 TO trailimit% + 1)
DIM SHARED hues%(1 TO 9, 0 TO 2)
DIM SHARED month%(1 TO 12)

SCREEN 12: standardwdw (screenheight%)
LoadMonths
InitColors
PlanetDataLoad t#
RestorPlanets backupplanets(), Planets()
switch% = -1: plan% = -1

'preliminary run assuming planets start at 01/01/2000
FOR z% = 1 TO 9
 Planets(z%, 6) = Planets(z%, 5) / trailimit%: i% = 0: p# = 0
 FOR y% = 3 TO 4: Planets(z%, y%) = Planets(z%, y%) / t# * Planets(z%, 6)
 NEXT
 DO
  RADIUS# = SQR(Planets(z%, 1) ^ 2 + Planets(z%, 2) ^ 2)
  a# = G * m * Planets(z%, 6) ^ 2 / RADIUS# ^ 2
  Planets(z%, 3) = Planets(z%, 3) - a# * Planets(z%, 1) / RADIUS#:     'velocity
  Planets(z%, 4) = Planets(z%, 4) - a# * Planets(z%, 2) / RADIUS#:     'velocity
  Planets(z%, 1) = Planets(z%, 1) + Planets(z%, 3):     'posit update
  Planets(z%, 2) = Planets(z%, 2) + Planets(z%, 4):     'posit update
  planetpathX(z%, i%) = Planets(z%, 1)
  planetpathY(z%, i%) = Planets(z%, 2)
  p# = p# + Planets(z%, 6)
  i% = i% + 1
  IF i% > trailimit% THEN
   planetpathX(z%, i%) = planetpathX(z%, 0)
   planetpathY(z%, i%) = planetpathY(z%, 0)
   EXIT DO
  END IF
 LOOP
NEXT

RestorPlanets Planets(), backupplanets()
inputstring start$, p#, now$

'main run
DrawPaths planetpathX(), planetpathY(), s
headings start$, t#, screenheight%, switch%, plan%, now$
DO
 timechange = 0
 FOR z% = firstp% TO lastp%
   RADIUS# = SQR(Planets(z%, 1) ^ 2 + Planets(z%, 2) ^ 2)
   i% = INT(p# / Planets(z%, 5) * trailimit%) MOD trailimit%
   COLOR z%: PSET (Planets(z%, 1) / s, Planets(z%, 2) / s)
   Planets(z%, 1) = planetpathX(z%, i%):    'posit update
   Planets(z%, 2) = planetpathY(z%, i%):    'posit update
   COLOR PlanetColor%: PSET (Planets(z%, 1) / s, Planets(z%, 2) / s)
   i% = keycheck(0)
   IF i% = ASC("C") THEN
    CALL setcolor: DrawPaths planetpathX(), planetpathY(), s
    headings start$, t#, screenheight%, switch%, plan%, now$
   END IF
   IF i% = -72 THEN
    ScaleChange start$, s, .5, PlanetColor%, t#, screenheight%, switch%, plan%, now$
   END IF
   IF i% = -80 THEN
    ScaleChange start$, s, 2, PlanetColor%, t#, screenheight%, switch%, plan%, now$
   END IF
   IF i% = -77 THEN BEEP: timechange = .5
   IF i% = -75 THEN BEEP: timechange = 2
   IF i% = ASC(" ") THEN
    switch% = NOT (switch%)
    headings start$, t#, screenheight%, switch%, plan%, now$
   END IF
   IF i% = ASC("P") THEN
    plan% = NOT (plan%)
    headings start$, t#, screenheight%, switch%, plan%, now$
   END IF
   COLOR 15: LOCATE 2, 29: PRINT clock(p#)
   LOCATE 4, 7: PRINT now$
   LOCATE 1, 1: PRINT
  NEXT
 IF timechange <> 0 THEN
  ChangeTime start$, t#, timechange, screenheight%, switch%, plan%, now$
 END IF
 p# = p# + t#: now$ = CnvrtElapToDate(p#, start$)
LOOP
END

'Month Data
DATA "jan",31
DATA "feb",28
DATA "mar",31
DATA "apr",30
DATA "may",31
DATA "jun",30
DATA "jul",31
DATA "aug",31
DATA "sep",30
DATA "oct",31
DATA "nov",30
DATA "dec",31

'Color Data
DATA 29,00,00
DATA 18,21,00
DATA 00,00,36
DATA 28,00,00
DATA 00,15,00
DATA 00,00,24
DATA 23,00,00
DATA 00,13,00
DATA 00,00,32

'Planet Data
'first ordinate    =number of body
'second ordinate  1=x position in metres
'                 2=y position in metres
'                 3=x velocity (distance in unit time)
'                 4=y velocity (distance in unit time)
'                 5=orbital time in seconds
'                 6=time interval in seconds between orig plotted points

DATA Mercury,87.97
DATA -2.159957E+10
DATA -6.632006E+10
DATA 36667.52
DATA -12969.32

DATA Venus,224.701
DATA -1.076705E+11
DATA 1.111402E+08
DATA -232.1984
DATA -35202.86

DATA Earth,365.256
DATA -2.074458E+10
DATA 1.456034E+11
DATA -29994.5#
DATA -4317.455#

DATA Mars,686.98
DATA 2.074664E+11
DATA -1.225537E+10
DATA 2346.5
DATA 26264.6

DATA Jupiter,4332.59
DATA 6.084891E+11
DATA 4.265652E+11
DATA -7661.248
DATA 11312.73

DATA Saturn,10759.2
DATA 9.819443E+11
DATA 9.579996E 11
DATA -7287.778
DATA 6886.043

DATA Uranus,30684.9
DATA 2.109939E+12
DATA -2.094706E+12
DATA 4759.126
DATA 4516.342

DATA Neptune,60190.3
DATA 2.413262E+12
DATA -3.807587E+12
DATA 4552.632
DATA 2942.215

DATA Pluto,90464.7798
DATA -1.640719E+12
DATA -4.195365E+12
DATA 5419.73
DATA -2663.793

FUNCTION ArcTan (h, v)
IF h = 0 AND v > 0 THEN gamma# = 0
IF h > 0 AND v > 0 THEN gamma# = ATN(h / v)
IF h > 0 AND v = 0 THEN gamma# = pi / 2
IF h > 0 AND v < 0 THEN gamma# = ATN(h / v) + pi
IF h = 0 AND v < 0 THEN gamma# = pi
IF h < 0 AND v < 0 THEN gamma# = ATN(h / v) + pi
IF h < 0 AND v = 0 THEN gamma# = pi * 3 / 2
IF h < 0 AND v > 0 THEN gamma# = ATN(h / v) + pi * 2
gamma# = (INT(gamma# * 1000)) / 1000
ArcTan = gamma#
END FUNCTION

FUNCTION BritDate$ (a$)
BritDate$ = MID$(a$, 4, 3) + LEFT$(a$, 3) + RIGHT$(a$, 4):
END FUNCTION

SUB ChangeTime (start$, t#, factor, screenheight%, switch%, plan%, now$)
t# = t# / factor
headings start$, t#, screenheight%, switch%, plan%, now$
END SUB

FUNCTION clock$ (chron#)
a$ = "31558118.4,86400,3600,"
'     years   ,days ,hrs.,mn,s,"
b% = 1: remainder# = chron#
answer$ = ""
DO
 c% = INSTR(b%, a$, ",")
 u# = VAL(MID$(a$, b%, c% - b%))
 w# = INT(remainder# / u#)
 remainder# = remainder# - w# * u#
 temp$ = RIGHT$(LTRIM$(STR$(w# + 1000)), 3)
 answer$ = answer$ + temp$ + ":"
 b% = c% + 1: IF b% > LEN(a$) THEN EXIT DO
LOOP
clock$ = LEFT$(answer$, LEN(answer$) - 1)
END FUNCTION

FUNCTION CnvrtElapToDate$ (p#, start$)
temp$ = clock(p#)
year% = 2000 + VAL(LEFT$(temp$, 3))
day% = VAL(MID$(temp$, 5, 3))
hour% = VAL(RIGHT$(temp$, 3))
DayAndMon day%, realday%, month%
realday$ = RIGHT$(STR$(realday% + 100), 2)
month$ = RIGHT$(STR$(month% + 100), 2)
temp$ = realday$ + "/" + month$ + "/" + RIGHT$(STR$(year%), 4)
CnvrtElapToDate$ = temp$
END FUNCTION

SUB DayAndMon (day%, realday%, month%)
month% = INT(day% / 30.417) + 1
realday% = day% - (month% - 1) * 30.417
IF month% = 3 THEN realday% = realday% + 1
IF realday% > month%(month%) THEN
 realday% = month%(month%)
END IF
IF month% = 5 OR month% = 7 OR month% = 8 OR month% = 10 OR month% = 12 THEN
 realday% = realday% + 1
END IF
END SUB

SUB DrawPaths (planetpathX(), planetpathY(), s)
CLS
FOR planet% = 1 TO n%
 COLOR planet%
 PSET (planetpathX(planet%, 0) / s, planetpathY(planet%, 0) / s)
 FOR i% = 1 TO trailimit% + 1 STEP 4
  LINE -(planetpathX(planet%, i%) / s, planetpathY(planet%, i%) / s)
 NEXT
NEXT
COLOR 15: PSET (0, 0)
END SUB

SUB headings (start$, t#, screenheight%, switch%, plan%, now$)
LOCATE 1, 1: PRINT "INTERVAL    /YEAR:DAY:HOUR= "; clock(t#)
LOCATE 2, 1: PRINT "TIME ELAPSED/YEAR:DAY:HOUR= "
LOCATE 3, 1: PRINT "START="; start$
LOCATE 4, 1: PRINT "DATE ="; now$
WINDOW
IF switch% THEN
 q$ = " " + CHR$(26) + " Speed.   Scale.Control+Pause=Stop.C=Colors.Space=Toggle this.P=Planet List"
ELSE
 q$ = STRING$(80, " ")
END IF
plotPRINT 30, 1, 15, 0, q$
y% = 5
FOR planet% = firstp% TO lastp%
 IF plan% THEN
  plotPRINT 3, 57 - y% * 3, 15, planet%, LCASE$(LEFT$(planetname$(planet%), 1) + " ")
 ELSE
  LOCATE 3, 57 - y% * 3: PRINT ("  ")
 END IF
 y% = y% + 1
NEXT
standardwdw screenheight%
END SUB

SUB InitColors
FOR y% = 1 TO 9
 FOR x% = 0 TO 2
  READ hues%(y%, x%)
 NEXT
NEXT
t$ = STRING$(27, "-")
SHELL "c:"
SHELL "cd \"
OPEN "Planets.col" FOR BINARY AS #1
 GET #1, , t$
 y% = LOF(1)
CLOSE #1
IF y% = 0 THEN KILL "planets.col"
IF ASC(LEFT$(t$, 1)) <> 0 THEN
 FOR y% = 1 TO 9
  FOR x% = 0 TO 2
   hues%(y%, x%) = ASC(MID$(t$, 1 + (y% - 1) * 3 + x%, 1))
  NEXT
 NEXT
END IF
FOR y% = 1 TO 9
 PALETTE y%, hues%(y%, 0) + (hues%(y%, 1) * 256) + (hues%(y%, 2) * 65536)
NEXT
END SUB

SUB inputstring (start$, p#, now$)
DO
 LOCATE 1, 1
 INPUT "Input starting point in form dd/mm/yyyy or Return=today:-", start$
 IF start$ = "" THEN
  start$ = BritDate(DATE$)
  MID$(start$, 3, 1) = "/"
  MID$(start$, 6, 1) = "/"
 END IF
 start$ = start$ + "             "
 ok% = -1
 IF MID$(start$, 3, 1) <> "/" THEN ok% = 0
 IF MID$(start$, 6, 1) <> "/" THEN ok% = 0
 day% = VAL(MID$(start$, 1, 2))
 mon% = VAL(MID$(start$, 4, 2))
 yer% = VAL(MID$(start$, 7, 4))
 IF day% < 1 OR day% > 31 THEN ok% = 0
 IF mon% < 1 OR mon% > 12 THEN ok% = 0
 IF yer% < 2000 OR yer% > 9999 THEN ok% = 0
 IF ok% THEN EXIT DO
 CLS : LOCATE 1, 1: PRINT "DATE IN WRONG FORMAT:TRY AGAIN": SLEEP 5
LOOP
start$ = LEFT$(start$, 10)
p# = ((day% - 1) * 30.438 / 31 + (mon% - 1) * 365.256 / 12 + (yer% - 2000) * 365.256)
p# = p# * 24 * 3600
now$ = CnvrtElapToDate(p#, start$)
END SUB

FUNCTION keycheck (a) : ' see what keys have been pressed
i$ = UCASE$(INKEY$)
IF LEN(i$) > 1 THEN
 i% = -ASC(RIGHT$(i$, 1))
ELSEIF i$ <> "" THEN
 i% = ASC(i$)
ELSE
 i% = 0
END IF
keycheck = i%
END FUNCTION

SUB LoadMonths
FOR month% = 1 TO 12
 READ temp$, monthlen%
 month%(month%) = monthlen%
NEXT
END SUB

SUB origin (Xorig#, Yorig#, wedth%, height%) : 'substitute for orig change command in BBC basic
WINDOW (-Xorig#, -Yorig#)-(wedth% - 1 - Xorig#, height% - 1 - Yorig#)
END SUB

SUB PlanetDataLoad (t#)
FOR planet% = 1 TO n%
 READ planetname$(planet%)
 READ days: Planets(planet%, 5) = days * 24 * 3600
 FOR y% = 1 TO 4
  READ Planets(planet%, y%)
 NEXT
 FOR y% = 3 TO 4
  Planets(planet%, y%) = Planets(planet%, y%) * t#
 NEXT
NEXT
END SUB

SUB plotPRINT (down, across, fore%, back%, a$)
h% = (across - 2) * 8: v% = (down - 1) * 16
FOR z% = 1 TO LEN(a$)
 FOR y% = 0 TO 7
  address& = 1047150 + ASC(MID$(a$, z%)) * 8 + y%
  DEF SEG = 4096 * (address& \ 65536)
  byte% = PEEK(address& MOD 65536)
  FOR x% = 0 TO 7
   IF byte% \ 2 ^ x% MOD 2 = 0 THEN
    IF back% <> -1 THEN COLOR back% ELSE COLOR POINT(h% + 7 - x% + z% * 8, v% + y% * 2 + 0)
   ELSE
    IF fore% <> -1 THEN COLOR fore% ELSE COLOR POINT(h% + 7 - x% + z% * 8, v% + y% * 2 + 0)
   END IF
   PSET (h% + 7 - x% + z% * 8, v% + y% * 2 + 0)
   PSET (h% + 7 - x% + z% * 8, v% + y% * 2 + 1)
  NEXT
 NEXT
NEXT
END SUB

FUNCTION RAD! (DEGREES)
RAD! = DEGREES * pi / 180'
END FUNCTION

SUB RestorPlanets (target(), source())
FOR z% = 1 TO 9
 FOR y% = 1 TO 6
  target(z%, y%) = source(z%, y%)
 NEXT
NEXT
END SUB

SUB ScaleChange (start$, s, factor, PlanetColor%, t#, screenheight%, switch%, plan%, now$)
COLOR PlanetColor%
s = s / factor
DrawPaths planetpathX(), planetpathY(), s
COLOR 15: PSET (0, 0)
headings start$, t#, screenheight%, switch%, plan%, now$
END SUB

SUB setcolor
CLS
LOCATE 1, 1: COLOR 15: PRINT "Set Colors:-"
FOR colour% = 1 TO 9
 LOCATE colour% * 2 + 1, 7
 COLOR colour%
 PRINT "   "; planetname$(colour%)
NEXT
COLOR 15
PRINT
PRINT "  = select planet. "; CHR$(26); " = select red/green/blue.< >=Change intensity.Escape=exit"
PRINT "Press S to save current settings in C:\Planets.Col file on computer and exit."
PRINT "To restore default colors delete the Planets.Col file from the PC"
y% = 1: x% = 0
DO
 LOCATE y% * 2 + 1, 7: PRINT ">"
 LOCATE y% * 2 + 1, 1
 IF x% = 0 THEN PRINT "RED"
 IF x% = 1 THEN PRINT "GREEN"
 IF x% = 2 THEN PRINT "BLUE"
 i% = keycheck(0)
 IF i% <> 0 THEN
  LOCATE y% * 2 + 1, 7: PRINT " "
  LOCATE y% * 2 + 1, 1: PRINT "     "
 END IF
 IF i% = -77 THEN x% = x% + 1: IF x% = 3 THEN x% = 2
 IF i% = -75 THEN x% = x% - 1: IF x% = -1 THEN x% = 0
 IF i% = -80 THEN y% = y% + 1: IF y% = 10 THEN y% = 9
 IF i% = -72 THEN y% = y% - 1: IF y% = 0 THEN y% = 1
 IF i% = ASC(".") THEN
  hues%(y%, x%) = hues%(y%, x%) + 1
  IF hues%(y%, x%) > 63 THEN hues%(y%, x%) = 63
  PALETTE y%, hues%(y%, 0) + (hues%(y%, 1) * 256) + (hues%(y%, 2) * 65536)
 END IF
 IF i% = ASC(",") THEN
  hues%(y%, x%) = hues%(y%, x%) - 1
  IF hues%(y%, x%) < 0 THEN hues%(y%, x%) = 0
  PALETTE y%, hues%(y%, 0) + (hues%(y%, 1) * 256) + (hues%(y%, 2) * 65536)
 END IF
 IF i% = ASC("S") THEN
  t$ = ""
  FOR y% = 1 TO 9: FOR x% = 0 TO 2
   t$ = t$ + CHR$(hues%(y%, x%))
  NEXT: NEXT
  OPEN "Planets.col" FOR BINARY AS #1
  PUT #1, , t$
  CLOSE #1
  i% = 27
 END IF
 IF i% = 27 THEN
  CLS : EXIT SUB
 END IF
LOOP
END SUB

FUNCTION SetScreenHeight (dummy%)
SHELL "cd\": SHELL "c:"
GOTO 10
OPEN "autoexec.bat" FOR BINARY AS #1
filelength = LOF(1)
test$ = "Bob Goddard"
t$ = test$
FOR count& = 1 TO filelength - LEN(t$)
 SEEK #1, count&: GET #1, , t$
 IF t$ = test$ THEN answer% = 960: EXIT FOR
NEXT
CLOSE #1
IF t$ <> test$ THEN answer% = 800
10 :
answer% = 960
SetScreenHeight = answer%
END FUNCTION

SUB standardwdw (screenheight%)
origin 640, screenheight% / 2, 1280, screenheight%
COLOR 15: PSET (0, 0): 'Sun
END SUB

